<template>
  <v-dialog
    v-model="modalValue"
    v-bind="attrs"
    scrollable
  >
    <v-card>
      <v-card-title class="h5 text-uppercase font-weight-light">
        <span class="mr-auto">{{ title }}</span>

        <v-btn
          text
          fab
          small
          @click="handleClose"
        >
          <v-icon color="red">
            mdi-close
          </v-icon>
        </v-btn>
      </v-card-title>

      <v-divider class="mb-5" />

      <v-card-text>
        <slot name="body"></slot>
      </v-card-text>

      <v-divider />

      <v-card-actions>
        <v-spacer />

        <slot name="footer"></slot>

        <v-btn
          color="grey"
          text
          @click="handleClose"
          v-text="closeText"
        />

        <v-btn
          v-if="!hideTriggerButton"
          color="green darken-1"
          text
          @click="handleTrigger"
          v-text="triggerText"
        />
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
export default {
  name: 'BaseModal',

  props: {
    value: {
      type: [Boolean, Number],
      default: false
    },

    triggerText: {
      type: String,
      default: 'Save'
    },

    hideTriggerButton: {
      type: [Boolean, Number],
      default: 0
    },

    closeText: {
      type: String,
      default: 'Close'
    },

    title: {
      type: String,
      default: ''
    },

    closeOnTrigger: {
      type: [Boolean, Number],
      default: 1
    }
  },

  data: () => ({
    modalValue: false
  }),

  computed: {
    attrs () {
      return {
        'max-width': 550,
        ...this.$attrs
      }
    }
  },

  watch: {
    value: {
      handler (val) {
        this.modalValue = val
      },
      immediate: true
    },

    modalValue (val) {
      this.$emit('input', val)
    }
  },

  methods: {
    handleClose () {
      this.$emit('close', true)
      this.modalValue = false
    },

    handleTrigger () {
      this.$emit('trigger', true)

      if (this.closeOnTrigger) {
        this.modalValue = false
      }
    }
  }
}
</script>
